<template>
	<section class="gallery" v-if="items && items.length">
    <div class="gallery__boxes layout layout--center">
      <div v-for="item in filteredItems"
        v-bind:key="item.attrs.carId" class="box-container">
        <gallery-box v-bind:car="item">
        </gallery-box>
     </div>
    </div>
    <paginator v-bind:pageCount="pageCount" v-bind:activePage="activePage" v-on:pageChange="onPageChange"></paginator>
  </section>
</template>

<script>
import GalleryBox from "@/components/GalleryBox";
import Paginator from "@/components/Paginator";

export default {
  name: "GalleryGrid",
  components: {
    GalleryBox: GalleryBox,
    Paginator: Paginator
  },
  props: ["items", "itemsPerPage", "activePage"],
  methods: {
    onPageChange: function(page) {
      this.$emit("pageChange", page);
    }
  },
  computed: {
    pageCount: function() {
      if (this.items && this.itemsPerPage) {
        return Math.ceil(this.items.length / this.itemsPerPage);
      }
      return 1;
    },
    filteredItems: function() {
      const begin = (this.activePage - 1) * this.itemsPerPage;
      const end = Math.min(begin + this.itemsPerPage, this.items.length);
      return this.items.slice(begin, end);
    }
  }
};
</script>

<style scoped lang="scss">
@import "../styles/breakpoints.scss";

.gallery__boxes {
  margin: 3em 0;
  align-items: baseline;
}

.box-container {
  @include media-breakpoint-only(xs) {
    width: 100%;
  }

  @include media-breakpoint-only(sm) {
    width: 50%;
  }
}
</style>

